"""Control Operating Systems."""

from __future__ import annotations

from typing import TYPE_CHECKING

from rwx.err import Error
from rwx.os.debian import Debian

if TYPE_CHECKING:
    from pathlib import Path


class OS:
    """Operating System."""

    def __init__(self, path: Path) -> None:
        """Set root."""
        self.root = path
        self.name = self.get_name()

    def get_name(self) -> str:
        """Return mandatory name."""
        raise Error

    @staticmethod
    def from_path(path: Path) -> OS:
        """Initialize from an already existing path."""
        return Debian(path)
